ImageMorph subclass: #GameImageMorph
	instanceVariableNames: 'filename imgsys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/15/2013 12:40'!
addMorphTo: aWindow
	""

	|  |
	aWindow addMorph: self.! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/15/2013 12:39'!
gamemorph
	""

	|  |
	^self! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/15/2013 12:58'!
initialize
	""
	| |
	imgsys := GameImgSys new.! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/15/2013 13:01'!
load: aFilename
	""
	| png |
	
	png := imgsys load: aFilename.
	self new image: png.! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/15/2013 13:26'!
new
	""

	|  |
	super initialize.
	self initialize.
	^self! !


GameImageMorph subclass: #GameBackgroundImageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!GameBackgroundImageMorph methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/16/2013 19:22'!
load
	""

	|  |
	self load: 'bg-1-320x200.png'.! !


GameImageMorph subclass: #GameEntityImageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!GameEntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:41'!
load: filename
	""

	|  |
	super load: filename.! !


Object subclass: #GameImgSys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!GameImgSys methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/15/2013 13:01'!
load: aFilename
	""

	| png |
	png := PNGReadWriter formFromFileNamed: aFilename.
	"png := png nextImage."

	^ png

"	self addMorph: mo".! !

!GameImgSys methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/15/2013 12:57'!
new
	""

	|  |
	super new.
	^ self.! !


GameImageMorph subclass: #GamePlayerImageMorph
	instanceVariableNames: 'width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!GamePlayerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:09'!
height
	||
	^ height.! !

!GamePlayerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:08'!
load
	""

	|  |
	width := 32.
	height := 32.
	self load: 'player-static-down-32x32.png'.! !

!GamePlayerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:09'!
width
	||
	^ width.! !


SystemWindow subclass: #GameWindow
	instanceVariableNames: 'playerimagemorph bgimagemorph room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:22'!
handleKeystroke: anEvent
	""
	| keyValue |
	keyValue := anEvent keyValue.

	keyValue = 30 "up arrow"
	ifTrue: [
		playerimagemorph position y <= self position y + 21 ifFalse:[
		playerimagemorph position: playerimagemorph position - (0 @ 1)]].

	keyValue = 31 "down arrow"
	ifTrue: [
		playerimagemorph position y >= self position y + (219-playerimagemorph width) ifFalse:[
		playerimagemorph position: playerimagemorph position + (0 @ 1)]].

	keyValue = 29 "right arrow"
	ifTrue: [
	playerimagemorph position x >= (self position x + 319) ifFalse:[		
		playerimagemorph position: playerimagemorph position + (1 @ 0)]].

	keyValue = 28 "left arrow"
	ifTrue: [
		playerimagemorph position x <= (self position x + 1) ifFalse:[
		playerimagemorph position: playerimagemorph position - (1 @ 0)]]! !

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 02:22'!
initialize
	""

	|  frame |
	super initialize.
	
	room := RoomFields new.
	room load.
	room position: 0@20.
	room addMorphTo:self.
	"bgimagemorph""self addMorph:""To:self""bgimagemorph frame:[Rectangle new center:320@220 extent:320@220]."
	"bgimagemorph openInWorld."
	"FIXME use a world for the bg scrolling"
	"bgimagemorph intoWorld:."
	playerimagemorph := GamePlayerImageMorph new.
	playerimagemorph load.
	playerimagemorph position: 120@100.
	frame := LayoutFrame new
	leftFraction:0 offset: 0;
	rightFraction:0 offset:0;
	topFraction:1 offset:0;
	bottomFraction:1 offset:0;
	yourself.

 	playerimagemorph addMorphTo:self."playerimagemorph frame:frame."
	"playerimagemorph openInWorld."
	"FIXME : Try to set the bounds where the player moves not out of the window"
	"playerimagemorph bounds:[Rectangle center:320@220 extent:320@200] from:bgimagemorph."	
! !

!GameWindow methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/16/2013 18:30'!
new
	""

	|  |
	super new.
	"super color: Color LightGray."

	^ self! !

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 00:17'!
show: aExtent
	
	self openInWorldExtent: aExtent.! !


GameBackgroundImageMorph subclass: #Room
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!


Room subclass: #RoomFields
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!RoomFields methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 02:22'!
load

	self load: 'bg-1-320x200.png'.! !


Object subclass: #StateImageLibrary
	instanceVariableNames: 'list index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:54'!
add: imagemorph
	list add: imagemorph.! !

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:58'!
do: aBlock
	list do: [aBlock]! !

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:56'!
get
	index >= list size ifTrue:[index = 0].

	index += 1.
	^ list at:(index-1).! !

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 01:57'!
get:y
	y >= list size ifTrue:[^0].
	
	^ list at:y.! !


Object subclass: #TestGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Game'!

!TestGame methodsFor: 'as yet unclassified' stamp: 'Copyright (C) 2015 Johan Ceuppens (jc) 8/16/2013 18:45'!
test
	""

	| window |

	window := GameWindow new.
	window initialize.


	"+20 for title bar"
	window show: 320@220.
	! !
